Foxit PDF RDK

Public Member Functions | Static Public Attributes | List of all members
GraphicsObjects Class Reference
Inheritance diagram for GraphicsObjects:

## Public Member Functions
| GenerateContent ()
| Generate contents of current graphics objects. More...
| GenerateContent (text_merge_option)
| Generate contents of current graphics objects. More...
| GetFirstGraphicsObjectPosition (filter)
| Get the position of first graphics object in graphics object list, based on type filter. More...
| GetGraphicsObject (index)
| Get a graphics object by index. More...
| GetGraphicsObject (position)
| Get the graphics object by position in graphics object list. More...
| GetGraphicsObjectCount ()
| Get the count of graphics objects in graphics object list. More...
| GetGraphicsObjectIndex (graphics_object)
| Get the index of a specified graphics object in graphics object list. More...
| GetGraphicsObjectPosition (graphics_object)
| Get the position of the specified graphics object. More...
| GetLastGraphicsObjectPosition (filter)
| Get the position of last graphics object in graphics object list, based on type filter. More...
| GetNextGraphicsObjectPosition (position, filter)
| Get the position of next graphics object in graphics object list, based on type filter and specified current position. More...
| GetPrevGraphicsObjectPosition (position, filter)
| Get the position of previous graphics object in graphics object list, based on type filter and specified current position. More...
| InsertGraphicsObject (position_insert_after, graphics_object)
| Insert a graphics object after the specified position. More...
| IsEmpty ()
| Check whether current object is empty or not. More...
| MoveGraphicsObjectByPosition (current_position, position_move_after)
| Move a graphics object from a position to another position. More...
| RemoveGraphicsObject (graphics_object)
| Remove a graphics object. More...
| RemoveGraphicsObjectByPosition (position)
| Remove a graphics object by position. More...

## Static Public Attributes
static | e_TextMergeBTET
| Merge consecutive BTETs as a new one. More...
static | e_TextMergeNone
| Enumeration for text merge. More...
static | e_TextMergeTJY
| Merge consecutive text-showing operators with equal y coordinates.

## Detailed Description

This class is used as a manager for graphics objects. It stores all its graphics objects in a graphics list, and use POSITION object to enumerate them. A valid POSITION object can be used to get one graphics object, insert new graphics object and even remove one.
If any graphics object is changed, or graphics object is inserted/removed, function GraphicsObjects.GenerateContent should be called to ensure that all these changes would be stored to PDF document. Please refer to function GraphicsObjects.GenerateContent for more details.
A PDF page's content usually consists of a sequence of graphics objects, that means PDF page is used like a manager for graphics objects as well. So class PDFPage is derived from class GraphicsObjects in order that class PDFPage can retrieve its graphics object.
A form XObject, a kind of graphics object, is a self-contained description of any sequence of graphics objects, so function FormXObject.GetGraphicsObjects can be used to retrieve a GraphicsObjects object from a form XObject in order to manage graphics objects which are contained in a form XObject.

See also
  PDFPage
  FormXObject
  GraphicsObject

## Member Function Documentation

## ◆ GenerateContent() [1/2]

GraphicsObjects.GenerateContent | ( |  | ) |

Generate contents of current graphics objects.

If any graphics object is changed, or graphics object is inserted/removed/moved, this function should be called before saving related PDF document to ensure that all these changes would be stored to PDF document. Since it may take a long time to generate content, user is not recommended to call this function frequently, but only call this function when necessary, for example, just before the related PDF document is to be saved.
When this function succeeds, and current graphics object represents a PDF page, user is recommended to re-parse the PDF page by function PDFPage.StartParse with parameter is_reparse true before doing some operation on page content; otherwise the result of the operation may be unexpected. For example, if render the PDF page without re-parsing PDF page after this function succeeds, the page content may not be rendered as expected or unexpected error may occur. Please refer to function PDFPage.StartParse for more details about re-parsing a PDF page.

Returns
  true means success, while false means failure.

## ◆ GenerateContent() [2/2]

GraphicsObjects.GenerateContent | ( | text_merge_option |  | ) |

Generate contents of current graphics objects.

If any graphics object is changed, or graphics object is inserted/removed/moved, this function should be called before saving related PDF document to ensure that all these changes would be stored to PDF document. Since it may take a long time to generate content, user is not recommended to call this function frequently, but only call this function when necessary, for example, just before the related PDF document is to be saved.
When this function succeeds, and current graphics objects represent a PDF page, user is recommended to re-parse the PDF page by function PDFPage.StartParse with parameter is_reparse true before doing some operation on page content; otherwise the result of the operation may be unexpected. For example, if render the PDF page without re-parsing PDF page after this function succeeds, the page content may not be rendered as expected or unexpected error may occur. Please refer to function PDFPage.StartParse for more details about re-parsing a PDF page.

Parameters

  [in] | text_merge_option | The merge option for text object. Please refer to values starting from GraphicsObjects.e_TextMergeNone and this should be one of these values.

Returns
  true means success, while false means failure.

## ◆ GetFirstGraphicsObjectPosition()

GraphicsObjects.GetFirstGraphicsObjectPosition | ( | filter |  | ) |

Get the position of first graphics object in graphics object list, based on type filter.

After getting a position in the graphics object list, then user can call function GraphicsObjects.GetGraphicsObject to get the graphics object with this position.

Parameters

  [in] | filter | Type filter that specifies which kind of graphics object is to be gotten. Please refer to values starting from GraphicsObject.e_TypeAll and this should be one of these values. GraphicsObject.e_TypeAll means for all kinds of graphics objects. Default value: GraphicsObject.e_TypeAll .

Returns
  A POSITION object that represents the position of first graphics object in graphics object list. null or 0 means there is no graphics object.

## ◆ GetGraphicsObject() [1/2]

GraphicsObjects.GetGraphicsObject | ( | index |  | ) |

Get a graphics object by index.

Parameters

  [in] | index | Index of a graphics object to be retrieved. Valid range: from 0 to (count-1). count is returned by function GraphicsObjects.GetGraphicsObjectCount.

Returns
  A graphics object. If there is any error, this function will return null.

## ◆ GetGraphicsObject() [2/2]

GraphicsObjects.GetGraphicsObject | ( | position |  | ) |

Get the graphics object by position in graphics object list.

Parameters

  [in] | position | A POSITION object that indicates the position in the graphics object list. It should not be null or 0.

Returns
  A GraphicsObject object. If there is any error, this function will return null.

## ◆ GetGraphicsObjectCount()

GraphicsObjects.GetGraphicsObjectCount | ( |  | ) |

Get the count of graphics objects in graphics object list.

Returns
  Count of graphics objects in graphics object list.

## ◆ GetGraphicsObjectIndex()

GraphicsObjects.GetGraphicsObjectIndex | ( | graphics_object |  | ) |

Get the index of a specified graphics object in graphics object list.

Parameters

  [in] | graphics_object | A graphics object whose index is to be retrieved. Please ensure that input graphics object belongs to current graphics objects.

Returns
  Index of specified graphics object in graphics object list. -1 means parameter graphics_object does not belong to current graphics object list.

## ◆ GetGraphicsObjectPosition()

GraphicsObjects.GetGraphicsObjectPosition | ( | graphics_object |  | ) |

Get the position of the specified graphics object.

Parameters

  [in] | graphics_object | A graphics object whose position is to be retrieved.

Returns
  Position of the specified graphics object. null means input graphics object does not belong to current graphics objects.

## ◆ GetLastGraphicsObjectPosition()

GraphicsObjects.GetLastGraphicsObjectPosition | ( | filter |  | ) |

Get the position of last graphics object in graphics object list, based on type filter.

After getting a position in the graphics object list, then user can call function GraphicsObjects.GetGraphicsObject to get the graphics object with this position.

Parameters

  [in] | filter | Type filter that specifies which kind of graphics object is to be gotten. Please refer to values starting from GraphicsObject.e_TypeAll and this should be one of these values. GraphicsObject.e_TypeAll means for all kinds of graphics objects. Default value: GraphicsObject.e_TypeAll .

Returns
  A POSITION object that represents the position of last graphics object in graphics object list. null or 0 means there is no graphics object.

## ◆ GetNextGraphicsObjectPosition()

GraphicsObjects.GetNextGraphicsObjectPosition | ( | position | ,
|  | filter |
| ) |  |

Get the position of next graphics object in graphics object list, based on type filter and specified current position.

After getting a position in the graphics object list, then user can call function GraphicsObjects.GetGraphicsObject to get the graphics object with this position.

Parameters

  [in] | position | A POSITION object that indicates a position in the graphics object list, whose next position is to be gotten. It should not be null or 0.
  [in] | filter | Type filter that specifies which kind of graphics object is to be gotten. Please refer to values starting from GraphicsObject.e_TypeAll and this should be one of these values. GraphicsObject.e_TypeAll means for all kinds of graphics objects. Default value: GraphicsObject.e_TypeAll .

Returns
  A POSITION object that represents the position of next graphics object in graphics object list. null or 0 means parameter position is the last position in graphics object list.

## ◆ GetPrevGraphicsObjectPosition()

GraphicsObjects.GetPrevGraphicsObjectPosition | ( | position | ,
|  | filter |
| ) |  |

Get the position of previous graphics object in graphics object list, based on type filter and specified current position.

After getting a position in the graphics object list, then user can call function GraphicsObjects.GetGraphicsObject to get the graphics object with this position.

Parameters

  [in] | position | A POSITION object that indicates a position in the graphics object list, whose previous position is to be gotten. It should not be null or 0.
  [in] | filter | Type filter that specifies which kind of graphics object is to be gotten. Please refer to values starting from GraphicsObject.e_TypeAll and this should be one of these values. GraphicsObject.e_TypeAll means for all kinds of graphics objects. Default value: GraphicsObject.e_TypeAll .

Returns
  A POSITION object that represents the position of previous graphics object in graphics object list. null or 0 means parameter position is already in the first position in graphics object list.

## ◆ InsertGraphicsObject()

GraphicsObjects.InsertGraphicsObject | ( | position_insert_after | ,
|  | graphics_object |
| ) |  |

Insert a graphics object after the specified position.

Parameters

  [in] | position_insert_after | Used to specify the position, in order to insert parameter graphics_object after this position. null means that parameter graphics_object will be inserted before all graphics objects.
  [in] | graphics_object | A graphics object to be inserted. User should ensure that parameter graphics_object belongs to the same PDF document as current graphics objects.

Returns
  The new position of the inserted graphics object.

Note
  When this function succeeds, function GraphicsObjects.GenerateContent should be called. Please refer to function GraphicsObjects.GenerateContent for more details.

## ◆ IsEmpty()

GraphicsObjects.IsEmpty | ( |  | ) |

Check whether current object is empty or not.

When the current object is empty, that means current object is useless.

Returns
  true means current object is empty, while false means not.

## ◆ MoveGraphicsObjectByPosition()

GraphicsObjects.MoveGraphicsObjectByPosition | ( | current_position | ,
|  | position_move_after |
| ) |  |

Move a graphics object from a position to another position.

Parameters

  [in] | current_position | Current position of the graphics object which is to be moved to new position.
  [in] | position_move_after | Used to specify the position, in order to move the graphics object specified by parameter current_position after this position. null means that the graphics object specified by parameter current_positionwill be moved before all graphics objects.

Returns
  New position of the moved graphics object.

Note
  When this function succeeds, function GraphicsObjects.GenerateContent should be called. Please refer to function GraphicsObjects.GenerateContent for more details.

## ◆ RemoveGraphicsObject()

GraphicsObjects.RemoveGraphicsObject | ( | graphics_object |  | ) |

Remove a graphics object.

To remove a graphics object by position (function GraphicsObjects.RemoveGraphicsObjectByPosition) is more direct and effective than to remove a graphics object directly (function GraphicsObjects.RemoveGraphicsObject).

Parameters

  [in] | graphics_object | A graphics object to be removed. Please ensure this graphics object belongs to current graphics objects.

Returns
  true means success, while false means failure.

Note
  When this function succeeds, function GraphicsObjects.GenerateContent should be called. Please refer to function GraphicsObjects.GenerateContent for more details.

## ◆ RemoveGraphicsObjectByPosition()

GraphicsObjects.RemoveGraphicsObjectByPosition | ( | position |  | ) |

Remove a graphics object by position.

To remove a graphics object by position (function GraphicsObjects.RemoveGraphicsObjectByPosition) is more direct and effective than to remove a graphics object directly (function GraphicsObjects.RemoveGraphicsObject).

Parameters

  [in] | position | Used to specify the position of a graphics object, to be removed. It should not be null or 0.

Returns
  true means success, while false means failure.

Note
  When this function succeeds, function GraphicsObjects.GenerateContent should be called. Please refer to function GraphicsObjects.GenerateContent for more details.

## Member Data Documentation

## ◆ e_TextMergeBTET

GraphicsObjects.e_TextMergeBTET
| static

Merge consecutive BTETs as a new one.

'/BT' is an operator in the content stream that indicates the start of a text object. '/ET' is an operator in the content stream that indicates the end of a text object. If the merge option is used, it will merge multiple consecutive '/BT' and '/ET' as a new one.

## ◆ e_TextMergeNone

GraphicsObjects.e_TextMergeNone
| static

Enumeration for text merge.

Values of this enumeration should be used alone.

No text merge.